<?php

class NukeEventSession
{
    /**
    * Set the default values for the Session.
    */
    function _setDefaultValues()
    {
        global $neConfig;
        $_SESSION['logged'] = false;
        $_SESSION['uid'] = 0;
        $_SESSION['loggedin']  = false;
        $_SESSION['password']  = false;
        $_SESSION['admin']     = false;
        $_SESSION['superuser'] = false;
        $_SESSION['password']  = false;
        $_SESSION['admin']     = false;
        $_SESSION['superuser'] = false;
		$_SESSION['username']  = $neConfig['default']['username'];
        $_SESSION['theme']     = $neConfig['default']['theme'];
        $_SESSION['lang']      = $neConfig['default']['lang'];
		return true;
    }


   /**
   * Set the current Data for a Session.
   */
    function _setSession($arrLoginData)
    {
        global $neConfig,$neDb;
        //Set the Data needet for a sucessfull login.
        $_SESSION['loggedin'] = true;
        foreach($arrLoginData as $name => $value){
            $_SESSION[$name] = $value;
        }

        /*Update the Login Information*/
        $strSession = $neDb->quote(session_id());
        $strIp = $neDb->quote($_SERVER['REMOTE_ADDR']);
        $strQuery  = 'UPDATE '.$neConfig['db']['userprefix'].'_users ';
        $strQuery .= 'SET session = '.$strSession.', ';
        $strQuery .= 'ip = '.$strIp.' ';
        $strQuery .= 'WHERE uid = '.$_SESSION['uid'];
        $result = $neDb->query($strQuery);
        return true;
    }
	function _setCookie($arrLoginData) {
	     $login['uid'] = $arrLoginData['uid'];
		 $login['password'] = $arrLoginData['password'];
		 setcookie('neSessLogin',serialize($login),time() + 3600 * 250); 
	}

    function _cookieLogin($cookie) {
	    global $neConfig,$neDb;
        $cookie = unserialize($cookie);
        $strQuery  = 'SELECT * ';
        $strQuery .= 'FROM '.$neConfig['db']['userprefix'].'_users ';
        $strQuery .= "WHERE uid = '$cookie[uid]' ";
        $strQuery .= "AND password = '$cookie[password]'";
		$result = $neDb->getRow($strQuery,DB_FETCHMODE_ASSOC);
        if ( is_array($result) ) {
            $this->_setSession($result);
            return true;
        } else {
            $this->loginFailed = true;
            $this->_setDefaultValues();
            return false;
        }
	}

    /**
    * Constructor for the NukeEventSession class.
    */
    function NukeEventSession()
    {
        global $neConfig, $neDb;
        /*Give the Session the name of the Website and start the Session.*/
        session_name('NE_SESS');
        session_start();
        /* if the User is logged in set the User Options*/
        if (isset($_SESSION['loggedin']) and $_SESSION['loggedin'] == true) {
            return true;
        /* else check for an Autologin Cookie */ 
        } elseif ( isset($_COOKIE['neSessLogin']) ) {
            $this->_cookieLogin($_COOKIE['neSessLogin']);
			return true;
        /* else set the default Values */
        } else {
            $this->_setDefaultValues();
			return true;
        }
    }

   /**
   * checks if the Userlogin is sucessfull.
   */
    function login($strUsername,$strPassword,$bolRemember)
    {
        global $neConfig, $neDb;
        $strUsername = $neDb->quote($strUsername);
        $strPassword = $neDb->quote(md5($strPassword));
        $strQuery  = 'SELECT * ';
        $strQuery .= 'FROM '.$neConfig['db']['userprefix'].'_users ';
        $strQuery .= "WHERE username = $strUsername ";
        $strQuery .= "AND password = $strPassword";
        $result = $neDb->getRow($strQuery,DB_FETCHMODE_ASSOC);
        if ( is_array($result) ) {
            $this->_setSession($result);
			if ( $bolRemember == true ) {
			    $this->_setCookie($result);
			}
			return true;
        } else {
            $this->loginFailed = true;
            $this->_setDefaultValues();
            return false;
        }
    }

   /**
   * adds an User to the User Database.
   */
    function addUser($strUsername,$strPassword,$strEmail)
    {
        global $neConfig, $neDb;
        $strUsername = $neDb->quote($strUsername);
        $strPassword = $neDb->quote(md5($strPassword));
        $strQuery  = 'SELECT * ';
        $strQuery .= 'FROM '.$neConfig['db']['userprefix'].'_users ';
        $strQuery .= "WHERE username = $strUsername ";
        $strQuery .= "AND password = $strPassword";
        $result = $neDb->getRow($strQuery,DB_FETCHMODE_ASSOC);
        if ( is_array($result) ) {
            $this->_setSession($result);
			if ( $bolRemember == true ) {
			    $this->_setCookie($result);
			}
			return true;
        } else {
            $this->loginFailed = true;
            $this->_setDefaultValues();
            return false;
        }
    }


    /**
    * Check if current Session is owned by an logged in User.
    * @return bool true if the User is Logged in, False if Anonymous
    */
    function isLoggedIn() {
        if ( $_SESSION['loggedin'] == true ) {
            return true;
        } else {
            return false;
        };
    }

    /**
    * Check if the current User is an Admin.
    * @return boolean true: if the User is Admin and the Password is correct
    *                 false: if the Password is incorect or the User is no Admin
    */
    function isAdmin($strModuleName='')
    {
        global $neConfig,$neDb;
        if ( empty($strModuleName) or ($strModuleName = 'admin')) {
            if ( $_SESSION['admin'] == true ) {
                return true;
            } else {
                return false;
            }
        } elseif ( $_session['superuser'] == true ) {
                return true;
        } elseif ( $SESSION['admin'] == true ) {
                $strQuery  = 'SELECT * FROM '.$neConfig['db']['prefix'].'_admin_permissons ';
                $strQuery .= 'WHERE module_name = '.$strModuleName;
                $strQuery .= 'AND user_id = '.$_SESSION['uid'];
                $result = $neDb->query($strQuery);
                if ( $result->numRows() >= 0 ) {
                    return true;
                } else {
                    return false;
                }
        } else {
                return false;
        }
    }//function isAdmin($strModuleName='')


    function isSuperUser()
    {
        if ( $_SESSION['superuser'] == true ) {
            return true;
        } else {
            return false;
        };
    }


    /**
    * returns the current users selected theme
    */
    function getTheme()
    {
        global $neConfig;
        if (@file_exists('themes/'.$_SESSION['theme'].'/theme.inc.php') ) {
            return $_SESSION['theme'];
        } else {
            return $neConfig['default']['theme'];
        }
    }

    function getName()
    {
        return $_SESSION['username'];
    }

    function getId()
    {
        return $_SESSION['uid'];
    }


    function getLang()
    {
	    global $neConfig;
        if ( isset($_SESSION['lang']) ) {
		    return $_SESSION['lang'];
		} else {
            return $neConfig['default']['lang'];
		}			
    }

    function logout()
    {
        $this->_setDefaultValues();
        return true;
    }
}
