<?php
/*==NukeEvent Portal System====================================================
Copyright 2002 by Christian Berg (xeniac@animanga.at)

Code based on PHP-NUKE Web Portal System Copyright (c) 2002 by
Francisco Burzi (fbc@mandrakesoft.com) http://phpnuke.org

This program is free software. You can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License.

FILENAME: includes/theme.class.php

ABSTRACT:
This is the Base Class for the Themeset.
============================================================================*/

class NukeEventBaseTheme
{
    var $theme;
    var $template;
    /**
    * the Constructor
    */
    function NukeEventBaseTheme($strTheme)
    {
        /*
         * Start Output Buffering.
         * It helps to reduce some Errors when sending Headers and after warning
         * Messages. Also i don't have to rewrite the Complete Code. :)
         */
        ob_start();
        $this->theme = $strTheme;
        $this->template = new HTML_template_ITX(THEME_PATH.$strTheme);
    }
    /**
    * Load the Template File for the Module
    */
    function setTemplate($strTemplateName){
        $this->template->loadTemplateFile($strTemplateName);
    }

    function getTemplate($strModulename,$strFile){
    global $neSession,$neModuleName;
        if (file_exists(THEME_PATH.$this->theme.'/'.$strModulename.'/'.$strFile)) {
            $new_template = new HTML_template_ITX(THEME_PATH.$this->theme.'/'.$strModulename);
        } else {
            $new_template = new HTML_template_ITX(MODULES_PATH.$strModulename.'/theme');
        }
        $new_template->loadTemplateFile($strFile) or die("$strFile not found");
        $new_template->setCallbackFunction('translate','neTranslate');
        return $new_template;
    }
    /**
    * Executes an block-xxx-.php File and returns the result.
    * @access private
    */
    function _includeBlockfile($blockfile)
    {
        $file = @file("blocks/block-$blockfile.php");
        if (!$file) {
            $strContent = neTranslate('blockfile-not-exists');
        } else {
            include("blocks/block-$blockfile.php");
        }
        if ( empty($strContent) ){
            $strContent = neTranslate('blockfile-no-output');
        }
        return $strContent;
    }



    /**
    *draws an Errorpage
    */
    function drawErrorpage($strTitle, $strContent)
    {
        $this->drawTitle($strTitle);
        $strBox = '
         <table>
          <tr>
           <td class="content" align="left" valign="middle">
            '.$strContent.'
           </td>
           <td class="content" rowspan="2"><img src="'.$this->getImageSrc('error').'"  border="0" /></td>
          </tr>
         </table>
        ';
        $this->drawDialogbox($strTitle, $strBox);
        $this->drawSite($strTitle);
        die();
    }


    /**
    *draw a left Box
    * @access private
    */
    function drawLeftBlock($strTitle,$strContent){
        $this->template->setCurrentBlock('leftblock');
        $this->template->setVariable('BLOCKTITLE',$strTitle);
        $this->template->setVariable('BLOCKCONTENT',$strContent);
        $this->template->parse('leftblock');
    }

    /**
    *draw a left Box
    * @access private
    */
    function drawRightBlock($strTitle,$strContent){
        $this->template->setCurrentBlock('rightblock');
        $this->template->setVariable('BLOCKTITLE',$strTitle);
        $this->template->setVariable('BLOCKCONTENT',$strContent);
        $this->template->parse('rightblock');
    }

    /**
    *draw a centerblock
    * @access private
    */
    function drawCenterBlock($strTitle,$strContent){
        $this->template->setCurrentBlock('centerblock');
        $this->template->setVariable('BLOCKTITLE',$strTitle);
        $this->template->setVariable('BLOCKCONTENT',$strContent);
        $this->template->parse('centerblock');
    }

    /**
    * @access private
    */
    function _drawBlocks()
    {
        global $neConfig, $neSession, $neDb, $neModuleName, $neOp,
               $neModuleLoader,$neTheme;
        /*Build the Querystring */
        $strQuery  = 'SELECT block_id, visible, position, block_type, title, ';
        $strQuery .= 'content, url, blockfile ';
        $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_blocks ';
        $strQuery .= "WHERE active='1' ";
        $strQuery .= "AND (module='ALL' ";
        if ($neModuleLoader="admin.php") {
            $strQuery .= 'OR module=\'admin\' ';
        } elseif ($neModuleLoader="index.php" and empty($neModuleName)){
            $strQuery .= 'OR module=\'INDEX\' ';
        }
        $strQuery .= "OR module='".$neModuleName."') ";
        $strQuery .= 'ORDER BY weight ASC';

        /*get the Result abort if an error occours*/
        $blocks_result = $neDb->query($strQuery);
        if ( DB::isError($blocks_result) ) {
            echo $blocks_result->getMessage();
            echo $strQuery;
            return false;
        }

        /* Process all Blocks in a while loop */
        while($blocks_result->fetchInto($block,DB_FETCHMODE_ASSOC) ) {
            if (
                ( $block['visible'] >= BLOCK_ONLYADMIN and $neSession->isAdmin() ) or
                ( $block['visible'] >= BLOCK_ONLYREGISTED and $neSession->isLoggedIn() ) or
                ( $block['visible'] >= BLOCK_ALLUSERS )
               )
            {
                switch($block['block_type']){
                case BLOCK_BLOCKMODULE:
                    /*Blockmodule*/
                    $block['content'] = $this->includeBlockfile($block['blockfile']);
                    break;
                /*HTML Formatted Content*/
                case BLOCK_HTMLBLOCK:
                    $block['content']=$block['content'];
                    break;
                  /*RSS Newsfeed*/
                case BLOCK_RSSFEED:
                    //$strContent=headlines($intId);
                    break;
                }

                switch ($block['position']) {
                   case BLOCK_LEFT:
                        $this->drawLeftBlock($block['title'],$block['content']);
                    break;
                  case BLOCK_RIGHT:
                        $this->drawRightBlock($block['title'],$block['content']);
                    break;
                  case BLOCK_CENTER:
                        $this->drawCenterBlock($block['title'],$block['content']);
                    break;
                }
            }//if
        }//while
        $blocks_result->free();
    }

    /**
    * @access private
    */
    function _drawAdminMenu() {
        global $neConfig, $neSession, $neDb, $neModuleName;
        $strAdminmenuTable = $neConfig['db']['prefix'].'_admin_menu';
        $strQuery  = "SELECT DISTINCT menu.module, module.title ";
        $strQuery .= "FROM ".$neConfig['db']['prefix'].'_admin_menu menu, ';
        $strQuery .=         $neConfig['db']['prefix'].'_modules module ';
        $strQuery .= "WHERE module.name = menu.module ";
        $strQuery .= "ORDER BY menu.module";

        $menu_result = $neDb->query($strQuery);
        if (DB::isError($menu_result)){
            echo "error: $strQuery<br>\n";
            die();
        }
        while (list($strModuleName, $strModuleTitle) = $menu_result->fetchRow()){
            if ( $neSession->isAdmin($strModuleName) ) {
                $this->template->setVariable('MODULE_LINK','admin.php?mod='.$strModuleName);
                $this->template->setVariable('MODULE_TITLE',neTranslate($strModuleTitle,true));
                if ($neModuleName == $strModuleName ) {
                    $strQuery   = "SELECT text, op ";
                    $strQuery  .= "FROM  $strAdminmenuTable ";
                    $strQuery  .= "WHERE module='$strModuleName' ";
                    $strQuery  .= "ORDER BY weight";
                    $entry_result = $neDb->query($strQuery);
                    if (DB::isError($entry_result)){
                        echo $strQuery;
                        break;
                    }
                    $this->template->setCurrentBlock('function');
                    while (list($strText, $strOp) = $entry_result->fetchRow()){
                        $this->template->setVariable('FUNCTION_LINK','admin.php?mod='.$strModuleName.'&amp;op='.$strOp);
                        $this->template->setVariable('FUNCTION_NAME',neTranslate($strText,true));
                        $this->template->parse('function');
                    }
                    $entry_result->free();
                }
                $this->template->parse('module');
            }
        }
    }

    function getHelplink($strName,$strModule,$strFile,$strAnchor = NULL){
        $strHelplink  ='help.php?mod='.urlencode($strModule);
        $strHelplink .='&amp;file='.urlencode($strFile);
        if ( !empty($strAnchor) ) {
            $strHelplink .='#'.urlencode($strAnchor);
        }
        $strJavaScript="popHelp('$strHelplink')";
        return '<a href="'.$strHelplink.'" onclick="popHelp(\''.$strHelplink.'\')" target="help">'.$strName.'</a>';
    }

    /**
    * draws an Title
    */
    function drawTitle($strTitle)
    {
        $this->template->setVariable('SITE_TITLE',$strTitle);
    }


    /**
    * draws an Dialog box
    */
    function drawDialogbox($strTitle, $strContent)
    {
        $this->template->setCurrentBlock('messagebox');
        $this->template->setVariable('TITLE',$strTitle);
        $this->template->setVariable('CONTENT',$strContent);
        $this->template->parse('messagebox');
    }

    /**
    * gets the Output from the Buffer, and draws the Complete Site.
   * @param string pagetitle
   */
    function drawSite($pagetitle='',$metatags=false) {
        global $neConfig, $neSession, $starttime, $neErrors;
        if ( is_array($metatags) ) {
            foreach ($metatags as $name => $value ) {
                $neConfig['meta'][$name] = $value;
            }
        }
        $strMetaTags = '';
		foreach ($neConfig['meta'] as $name => $value) {
		   $strMetaTags .= '<meta name="'.$name.'" content="'.$value.'" />'."\n";
		}
        $strMainContent = ob_get_contents();
        ob_end_clean();
        $this->_drawBlocks();
        
        if ($neModuleLoader="admin.php"){
            $this->_drawAdminmenu();
        }
        $strFooterMsg = '';
        unset($strFooter);
        $timeparts = explode(' ',microtime());
        $endtime = $timeparts[1].substr($timeparts[0],1);

        $this->template->setVariable(array(
            'USERNAME' => $neSession->getName(),
        	'SITENAME' => $neConfig['site']['name'],
        	'PAGETITLE' => $pagetitle,
        	'METATAGS' => $strMetaTags,
        	'THEME' => $this->theme,
        	'MAINCONTENT' => $strMainContent,
        	'FOOTER' => $neConfig['site']['footer'],
        ));
       if (is_array($neErrors) AND $neSession->isSuperUser()) {
       	   $this->template->setVariable(array(
               'LABEL_ERROR_TYPE' => neTranslate('error_type'),
               'LABEL_ERROR_MESSAGE' => neTranslate('error_message'),
               'LABEL_ERROR_FILE' => neTranslate('file'),
               'LABEL_ERROR_LINE' => neTranslate('line'),       	   
       	   ));
       	   $this->template->setCurrentBlock('error');
           foreach($neErrors as $error ) { 
               $this->template->setVariable(array(
               'ERROR_TYPE' => $error['type'],
               'ERROR_MESSAGE' => $error['message'],
               'ERROR_FILE' => $error['file'],
               'ERROR_LINE' => $error['line'],
               ));
               $this->template->parse('error');
            }
       }    
        $this->template->show();
    }
    
    
    /**
    * Returns an Image Tag with the Image
    */
    function getImageSrc($strImageName, $strImagePath='')
    {
        if ( empty($strImagePath) ) {
            $strImagePath = IMAGE_PATH;
        } 
    	global $neSession;
        if(file_exists(THEME_PATH.$this->theme.'/images/'.$strImageName.'.png')){
            $strImageName = THEME_PATH.$this->theme.'/images/'.$strImageName.'.png';
        } elseif(file_exists(THEME_PATH.$this->theme.'/images/'.$strImageName.'.jpg')){
            $strImageName = THEME_PATH.$this->theme.'/images/'.$strImageName.'.jpg';
        } elseif(file_exists(THEME_PATH.$this->theme.'/images/'.$strImageName.'.gif')){
            $strImageName = THEME_PATH.$this->theme.'/images/'.$strImageName.'.gif';
        } elseif(file_exists($strImagePath.$strImageName.'.png')){
            $strImageName = $strImagePath.$strImageName.'.png';
        } elseif(file_exists($strImagePath.$strImageName.'.jpg')){
            $strImageName = $strImagePath.$strImageName.'.jpg';
        } elseif(file_exists($strImagePath.$strImageName.'.gif')){
            $strImageName = $strImagePath.$strImageName.'.gif';
        } else {
            return false;
        }
        return $strImageName;
    }

    function getImage($strImageName, $strAltText,$strImagePath='')
    {

        $strImageName= $this->getImageSrc($strImageName,$strImagePath);
        @$size = getimagesize ($strImageName);
        return '<img src="'.$strImageName.'" '.$size[3].' alt="'.$strAltText.'" title="'.$strAltText.'" border="0" />';
    }

    function drawImage($strImageName, $strAlttext,$strImagePath='')
    {
        echo $this->getImage($strImageName, $strAlttext,$strImagePath='');
    }

    function getUserinfo($intUserId){
        return neGetUserName($intUserId);
    }

    function getHtmlBox($strName,$strContent)
    {
    return '
    <textarea style="width:100%" rows="20" cols="60" class="htmlarea" name="'.$strName.'"
     id="'.$strName.'">'.htmlspecialchars($strContent).'</textarea>';
    }

    function getUbbBox($strName,$strContent,$intRows=10,$intCols=50)
    {
        $return = '<script type="text/javascript" src="javascript/ubbeditor.js" language="JavaScript"></script>';
        $return .= '<div class="toolbar">';

        $return .= '<a href="javascript:insertUbb(\'b\',\''.$strName.'\')">';
        $return .= $this->getImage('ubb_editor/bold',neTranslate('bold'));
        $return .= '</a>';

        $return .= '<a href="javascript:insertUbb(\'i\',\''.$strName.'\')">';
        $return .= $this->getImage('ubb_editor/italic',neTranslate('italic'));
        $return .= '</a>';

        $return .= '<a href="javascript:insertUbb(\'u\',\''.$strName.'\')">';
        $return .= $this->getImage('ubb_editor/underline',neTranslate('underline'));
        $return .= '</a>';

        $return .= '<a href="javascript:insertUbb(\'s\',\''.$strName.'\')">';
        $return .= $this->getImage('ubb_editor/strike',neTranslate('strikethrought'));
        $return .= '</a>';

        $return .= '<a href="javascript:insertUbb(\'sup\',\''.$strName.'\')">';
        $return .= $this->getImage('ubb_editor/sup',neTranslate('superscript'));
        $return .= '</a>';

        $return .= '<a href="javascript:insertUbb(\'sub\',\''.$strName.'\')">';
        $return .= $this->getImage('ubb_editor/sub',neTranslate('subscript'));
        $return .= '</a>';

        $return .= '<a href="javascript:insertImage(\''.$strName.'\')">';
        $return .= $this->getImage('ubb_editor/image',neTranslate('insert image'));
        $return .= '</a>';
        
        $return .= '</div>';
        $return .=  '<textarea rows="'.$intRows.'" cols="'.$intCols.'" class="ubbarea" id="'.$strName.'" name="'.$strName.'" style="width:100%">';
        $return .=  $strContent;
        $return .=  '</textarea>'."\n";
        return $return;
    }


}
?>
