<?php

/**
* Displays the Site.
*/
function displayContent($strName)
{
    global $neConfig, $neSession, $neDb, $neTheme;
    $strQuery  = 'SELECT title, content, active FROM ';
    $strQuery .=  $neConfig['db']['prefix'].'_content ';
    $strQuery .= "WHERE page_name='$strName' " ;
    $strQuery .= "AND (page_lang='".$neSession->getLang()."' " ;
    $strQuery .= "OR page_lang='') " ;      
    $page = $neDb->getRow($strQuery,DB_FETCHMODE_ASSOC);
    neGetDbError($page,__LINE__,__FILE__,$strQuery);
    if ($page['active'] == 1 or $page['active'] == 0 and $neSession->isAdmin('content')){
        echo stripslashes($page['content']);
    } else {
        $neTheme->drawErrorpage(
            _('This page is not active'),
            _('This Page is not active. Please inform an administrator about this issue.')
        );
    }
    if ($neSession->isAdmin('content')){
      	echo '<div style="text-align:right">';
        echo '<a href="admin.php?mod=content&amp;op=edit&amp;name='.urlencode($strName).'">';
        $neTheme->drawImage('edit',neTranslate('edit'));
        echo '</a></div>';
    }
    $neTheme->DrawSite(stripslashes($page['title']));
}


//==Admin Functions============================================================

/**
* Submits changes to a Page in the Database, or add the Page if it does not exist.
*/
function submitPage($strName, $strTitle, $strContent)
{
    global $neConfig, $neDb, $neSession;
    $strName    = $neDb->quote(neCheckText($strName,'plain'));
    $strTitle   = $neDb->quote(neCheckText($strTitle,'plain'));
    $strContent = $neDb->quote(neCheckText($strContent,'html'));
    $strAuthor  = $neDb->quote( (int) $neSession->uid);
    
    // Look if the Page exist
    $strQuery  = 'SELECT page_name FROM '.$neConfig['db']['prefix'].'_content ';
    $strQuery .= "WHERE page_name=$strName";
    $result = $neDb->query($strQuery);
    neGetDbError($result, __FILE__, __LINE__,$strQuery);

    //Do we edit a Page, or do we have to add a new?
    if ( $result->numRows() > 0 ) {
        $strQuery  = 'UPDATE '.$neConfig['db']['prefix'].'_content ';
        $strQuery .= "SET title=$strTitle, ";
        $strQuery .= "content=$strContent, ";
        $strQuery .= "author=$strAuthor ";       
        $strQuery .= "WHERE page_name=$strName";
    } else {
        $strQuery  = 'INSERT INTO '.$neConfig['db']['prefix'].'_content';
        $strQuery .= '(page_name,title,content,author,active) ';
        $strQuery .= "VALUES($strName,$strTitle,$strContent,$strAuthor,'0')";
    }
    $result = $neDb->query($strQuery);
    neGetDbError($result, __FILE__, __LINE__,$strQuery);
    return true;
}

/**
* removes the Site from the Database.
*/
function deletePage($strName) 
{
    global $neConfig, $neDb, $neModuleName;
    $strQuery  = 'DELETE FROM '.$neConfig['db']['prefix'].'_content ';
    $strQuery .= 'WHERE page_name="'.$strName.'" LIMIT 1';
    $result = $neDb->query($strQuery);
    neGetDbError($result, __LINE__, __FILE__);
    neRedirect('admin.php?mod='.$neModuleName.'&op=admin_content');
}

/**
 * Sets a Module to active.
 * @param integer Module ID.
 */
function activatePage($strName)
{
    global $neConfig, $neDb, $neTheme;
    $strQuery  = 'UPDATE '.$neConfig['db']['prefix'].'_content ';
    $strQuery .= "SET active='1' WHERE page_name='$strName'";
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
    neRedirect('admin.php?mod=content');
}


/**
 * Sets a Module to inactive.
 * @param integer Module ID.
 */
function deactivatePage($strName)
{
    global $neConfig, $neDb, $neTheme;
    $strQuery  = 'UPDATE '.$neConfig['db']['prefix'].'_content ';
    $strQuery .= "SET active='0' WHERE page_name='$strName'";
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
    neRedirect('admin.php?mod=content');
}


function exportPage($strName) {
    global $neConfig, $neDb, $neTheme, $neModuleName;
    $strQuery  = 'SELECT title, content, author ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_content ';
    $strQuery .= 'WHERE page_name='.$neDb->quote($strName);
    $result = $neDb->getRow($strQuery);
    neGetDbError($result,__LINE__,__FILE__, $strQuery);
    list($strTitle, $strContent,$strAuthor) = $result;
    header('Content-Type: application/octet-stream');
    header('Expires: ' . gmdate('D, d M Y H:i:s') . ' GMT');
    header('Content-Disposition: attachment; filename="'.$strName.'.html"');
    header('Content-Disposition: inline; filename="'.$strName.'.html"');
    header('Cache-Control: must-revalidate, post-check=0, pre-check=0');
    header('Pragma: public');
    header('Pragma: no-cache');
    ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN">
<html xmlns="http://www.w3.org/1999/xhtml"  xml:lang="{LANG}">
<head>
<title><?php echo $strTitle; ?></title>
</head> 
<body>
<?php echo $strContent; ?>
</body>
</html>    
    <?php
}

function editPage($strName) {
    global $neConfig, $neDb, $neTheme, $neModuleName;
    $strQuery  = 'SELECT title, content, author ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_content ';
    $strQuery .= 'WHERE page_name='.$neDb->quote($strName);
    $result = $neDb->getRow($strQuery);
    neGetDbError($result,__LINE__,__FILE__, $strQuery);
    list($strTitle, $strContent,$strAuthor) = $result;
    showEditForm($strName,$strTitle,$strContent,$strAuthor);
}
/**
*Show the edit Topic Form.
*/
function showEditForm($strName,$strTitle,$strContent,$strAuthor)
{
    global $neConfig, $neDb, $neTheme, $neModuleName;
    $tpl = $neTheme->getTemplate($neModuleName,"edit_page.tpl");
    $neTheme->drawTitle( neTranslate('edit_page') );
    $tpl->setVariable('PAGE_NAME',$strName);
    $tpl->setVariable('PAGE_TITLE', $strTitle);
    $tpl->setVariable('PAGE_CONTENT', $neTheme->getHtmlBox('content',$strContent));

    $tpl->setVariable('LABEL_EDIT_PAGE', neTranslate('edit_page'));
    $tpl->setVariable('LABEL_PAGE_NAME', neTranslate('page_name'));
    $tpl->setVariable('LABEL_PAGE_TITLE', neTranslate('page_title'));
    $tpl->setVariable('LABEL_PAGE_CONTENT', neTranslate('page_content'));
    $tpl->setVariable('LABEL_BACKTO_CONTENT', neTranslate('back_to_content'));
    $tpl->show();
    $neTheme->drawSite();
}


/**
* Displays the Site.
*/
function previewContent($strName,$strTitle,$strContent,$strAuthor)
{
    global $neConfig, $neSession, $neDb, $neTheme;
    echo $strContent;
    $neTheme->DrawSite($strTitle);
}

/**
* Show the Administrative Content Interface.
*/
function adminContent()
{
    global $neConfig, $neDb, $neTheme, $neModuleName;
    $strTopicsTable = '';
    $count = 0;
    $strQuery  = 'SELECT page_name, author, title, active ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_content ';
    $strQuery .= 'ORDER BY page_name';
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
    $neTheme->drawTitle(neTranslate('content_admin'));
	$tpl = $neTheme->getTemplate($neModuleName,'admin_content.tpl');
	$tpl->setVariable(array(
       'LABEL_NAME'   => neTranslate('name'),
       'LABEL_TITLE'  => neTranslate('title'),
       'LABEL_AUTHOR' => neTranslate('author'),
       'LABEL_ACTIVE' => neTranslate('active'),
       'LABEL_FUNCTIONS' => neTranslate('functions'),
	   'LABEL_ADDPAGE' => neTranslate('add_page'),
       'ADDPAGE_LINK' => 'admin.php?mod=content&amp;op=add',
	));
    while(list($strName, $strAuthor,$strTitle, $bolActive) = $result->fetchRow()) {
        $tpl->setCurrentBlock('page');
		$tpl->setVariable(array(
		    'NAME' => $strName,
		    'PREVIEW_LINK' => 'admin.php?mod=content&amp;op=show&amp;name='.$strName,
		    'TITLE' => $strTitle,
		    'AUTHOR' => neGetUserName($strAuthor),		
            'EXPORT' => '<a href="admin.php?mod=content&amp;op=export&amp;name='.$strName.'">'.$neTheme->getImage('save',neTranslate('export',1)).'</a>',
            'DELETE' => '<a href="admin.php?mod=content&amp;op=delete&amp;name='.$strName.'">'.$neTheme->getImage('delete',neTranslate('delete',1)).'</a>',
            'EDIT' => '<a href="admin.php?mod=content&amp;op=edit&amp;name='.$strName.'">'.$neTheme->getImage('edit',neTranslate('edit',1)).'</a>'
));
        if ($bolActive == 1) {
            $tpl->setVariable(
			    'ACTIVE',
				'<a href="admin.php?mod=content&amp;op=deactivate&amp;name='
				.$strName.'">'.$neTheme->getImage('ledgreen',
				neTranslate('active')).'</a>'
			);
        } else {
            $tpl->setVariable(
			    'ACTIVE',
			    '<a href="admin.php?mod=content&amp;op=activate&amp;name='
			    .$strName.'">'.$neTheme->getImage('ledred',
				neTranslate('inactive')).'</a>'
			);
        }
		$tpl->parse('page');
    }
	$tpl->show();
    $neTheme->DrawSite();
}
?>
