<?php

/**
 * Testet ob der die bermittelten Daten Korrekt sind.
 * @param array Associatives Array mit den Eventdaten. Die Feldnamen entsprechen der Tabelle $prefix_events
 */
function checkEventSubmit($event)
{
    global $neSession;
    if (isset($event['event_id'])){
        $event['event_id'] = (int) $event['event_id'];
    } else {
        $event['event_id'] = (int) time();
    }

    if (isset($event['event_title'])){
        $event['event_id'] = neCheckText($event['event_id'],'plain');
    } else {
        $event['event_title'] = neTranslate('no_title');
    }

    if (isset($event['event_location'])){
        $event['event_location'] = (int) $event['event_location'];
    } else {
        $event['event_location'] = 0 ;
    }

    if (isset($event['event_autor'])){
        $event['event_autor'] = (int) $event['event_autor'];
    } else {
        $event['event_autor'] = (int) $neSession->getId() ;
    }

    if (isset($event['event_abstract'])){
        $event['event_abstract'] = neCheckText($event['event_abstract'],'plain');
    } else {
        $event['event_abstract'] = neTranslate('no_abstract');
    }

    if (isset($event['event_description'])){
        $event['event_description'] = neCheckText($event['event_description'],'ubb');
    } else {
        $event['event_description'] = neTranslate('no_description');
    }

    return $event;
}


function displayEventPreview($event)
{
    global $dbi;
    echo "<h4>$event[Summary]</h4>";
    echo "<b>Von:</b>".strftime('%d.%m.%Y %H:%M',$event['EventStart'])." ";
    echo "<b>Bis:</b>".strftime('%d.%m.%Y %H:%M',$event['EventEnd']);
    echo "<p>$event[Detail]</p>";
}

/**
* Zeichent das Submit Formular.
* @parameter array Ein Array mit den ganzen Eventinformationen
*/

function drawSubmitForm($event,$op) {
    global $neTheme;
    $tpl = $neTheme->getTemplate('events','event_form.tpl');
    $tpl->setVariable(array(
    	'LABEL_AUTOR' => neTranslate('autor'),
    	'LABEL_TITLE' => neTranslate('title'),
    	'LABEL_ABSTRACT' => neTranslate('abstract'),
    	'LABEL_DESCRIPTION' => neTranslate('description'),
    	'LABEL_LOCATION' => neTranslate('location'),
    	'LABEL_SUBMIT' => neTranslate('submit'),
    	'LABEL_PREVIEW' => neTranslate('preview'),
    	
        'EVENT_ID' => $event['event_id'],
        'EVENT_AUTOR' => $neTheme->getUserInfo($event['event_autor']),
        'EVENT_TITLE' => $event['event_title'],
        'EVENT_ABSTRACT' => $event['event_abstract'],
        'EVENT_DESCRIPTION' => $neTheme->getUbbbox(
		'event[event_description]',
		$event['event_description']
	),
        'EVENT_LOCATION' => $event['event_location'],
        'AUTOR_ID' => $event['event_autor'],
       	'SUBMIT_OP' => $op
    ));
    $tpl->show();
}

/**
* neuen Event eintragen
*/
function newEvent($event) {
    global $neTheme,$neSession;
    $neTheme->drawTitle(neTranslate('add_new_event'));
    drawSubmitForm($event,'submit_add');
    $neTheme->drawSite();
}

function PreviewStory($event) {
    global $neTheme;
    $neTheme->drawTitle(neTranslate('preview_new_comment'));
    //displayEventPreview($event);
    drawSubmitForm($event,'submit_add');
    $neTheme->drawSite();
}

function submitEvent($event) {
    global $neTheme,$neDb,$neConfig;
    $event = checkEventSubmit($event);
    $strFields = "active";
    $strValues = 0;
    foreach ($event as $fieldName => $fieldValue){
        $strFields .= ",$fieldName";
        $strValues .= ','.$neDb->quote($fieldValue);
    }
    $strQuery   = 'INSERT INTO '.$neConfig['db']['prefix'].'_events';
    $strQuery .= '('.$strFields.') ';
    $strQuery .= 'VALUES ('.$strValues.') ';
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
    neRedirect('index.php?mod=events&op=edit_dates&id='.$event['event_id']);
}
?>