<?php

/**
* deletes an Article
*/
function deleteArticle($intId)
{
    global $neConfig, $neDb, $neTheme;
    echo "$intId will gelöscht werden";
    $strQuery  = 'DELETE FROM '.$neConfig['db']['prefix'].'_news ';
    $strQuery .= 'WHERE article_id='.$neDb->quote($intId);
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
}

/**
* deletes an Article
*/
function showDeleteQuestion($intId)
{
    global $neConfig, $neDb, $neTheme;
    $strMessage  = '<p>'.neTranslate('text-really_delete').': ';
    $strMessage .= $intId.'</p>';
    $strMessage .= '<a href="admin.php?mod=news&amp;op=delete_article&amp;id='.$intId.'">';
	$strMessage .= neTranslate('delete');
	$strMessage .= '</a>';
    $neTheme->drawTitle(neTranslate('delete_article'));
    $neTheme->drawDialogbox(neTranslate('delete_article'),$strMessage);
    $neTheme->drawSite(neTranslate('delete'));
}


/**
* Activates an waiting Article
*/
function activateArticle($intId)
{
    global $neConfig, $neDb;
    $intId = $neDb->quote($intId);
    $strQuery  = 'UPDATE '.$neConfig['db']['prefix'].'_news ';
    $strQuery .= 'SET waiting=\'0\' ';
    $strQuery .= "WHERE article_id=$intId";
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
}

/**
* Deactivates an Article
*/
function deactivateArticle($intId)
{
    global $neConfig, $neDb;
    $intId = $neDb->quote($intId);
    $strQuery  = 'UPDATE '.$neConfig['db']['prefix'].'_news ';
    $strQuery .= 'SET waiting=\'1\' ';
    $strQuery .= "WHERE article_id=$intId";
    $result = $neDb->query($strQuery);
     neGetDbError($result,__LINE__,__FILE__,$strQuery);
}

/**
* Saves the changes of the Article to the Database.
*/
function submitEditArticle($arrFormdata) {
    global $neDb,$neConfig;
    $arrSubmitdata['article_id'] = $neDb->quote($arrFormdata['article_id']);
    $arrSubmitdata['title'] = $neDb->quote($arrFormdata['title']);
    $arrSubmitdata['author'] = $neDb->quote($arrFormdata['author']);
    $arrSubmitdata['topic'] = $neDb->quote($arrFormdata['topic']);
    $arrSubmitdata['abstract'] = $neDb->quote($arrFormdata['abstract']);
    $arrSubmitdata['text'] = $neDb->quote($arrFormdata['text']);

    $strQuery  = 'UPDATE '.$neConfig['db']['prefix'].'_news ';
    $strQuery .= 'SET ';
    $strQuery .= "title=$arrSubmitdata[title], ";
    $strQuery .= "author=$arrSubmitdata[author],";
    $strQuery .= "topic=$arrSubmitdata[topic],";
    $strQuery .= "abstract=$arrSubmitdata[abstract],";
    $strQuery .= "text=$arrSubmitdata[text] ";
    $strQuery .= "WHERE article_id=$arrSubmitdata[article_id]";
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
}

function adminNews()
{
    global $neConfig, $neDb, $neTheme, $neSession, $neModuleName;
    $tpl = $neTheme->getTemplate($neModuleName,'news_admin.tpl');

    /* Build the database Query for the waiting News*/
    $strQuery  = 'SELECT news.article_id,topics.topic_id,topics.topic_name,';
    $strQuery .= 'topics.topic_title,news.author,news.created,news.title,';
    $strQuery .= 'news.abstract,news.text ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_news news, ';
    $strQuery .= $neConfig['db']['prefix']."_topics topics ";
    $strQuery .= 'WHERE topics.topic_id = news.topic ';
    $strQuery .= 'AND news.waiting = \'1\' ';
    $strQuery .='ORDER BY news.created DESC';

    /* Fetch the waiting news */
    $newsWaiting = $neDb->query($strQuery);
    neGetDbError($newsWaiting,__LINE__,__FILE__,$strQuery);
    $tpl->setCurrentBlock('waitingnews');
    $tpl->setVariable(array(
        'LABEL_WAITING_NEWS' => neTranslate('news_waiting'),
        'TEXT_NEWS_WAITING' => neTranslate('text-news_waiting'),
        'LABEL_TITLE' => neTranslate('title'),
        'LABEL_TOPIC' => neTranslate('topic'),
        'LABEL_CREATED' => neTranslate('created'),
        'LABEL_AUTHOR' => neTranslate('author'),
        'LABEL_FUNCTIONS' => neTranslate('functions'),
        'LABEL_NEW_ARTICLE' => neTranslate('new_article'),
        'LINK_NEW_ARTICLE' => 'admin.php?mod=news&amp;op=new'
    ));
    if ( $newsWaiting->numRows() > 0 ) {
	    $tpl->setCurrentBlock('waitingnewsitem');
        while ($newsWaiting->fetchInto($news,DB_FETCHMODE_ASSOC)) {
            $news['author'] = $neTheme->getUserInfo($news['author']);
            $news['edit']  = '<a href="admin.php?mod=news&amp;op=edit&amp;id=';
            $news['edit'] .= $news['article_id'].'">';
            $news['edit'] .= $neTheme->getImage('edit',neTranslate('edit'));
            $news['edit'] .= '</a>';
            $news['edit_links']  = '<a href="admin.php?mod=news&amp;op=edit_links&amp;id=';
            $news['edit_links'] .= $news['article_id'].'">';
            $news['edit_links'] .= $neTheme->getImage('link',neTranslate('edit_links'));
            $news['edit_links'] .= '</a>';
            $news['edit_images']  = '<a href="admin.php?mod=news&amp;op=edit_images&amp;id=';
            $news['edit_images'] .= $news['article_id'].'">';
            $news['edit_images'] .= $neTheme->getImage('image',neTranslate('edit_images'));
            $news['edit_images'] .= '</a>';
            $news['delete']  = '<a href="admin.php?mod=news&amp;op=delete&amp;';
            $news['delete'] .= 'id='.$news['article_id'].'">';
            $news['delete'] .= $neTheme->getImage('delete','delete');
            $news['delete'] .= '</a>';
            $tpl->setVariable(array(
                'TITLE' =>  $news['title'],
                'TOPIC_TITLE' =>  $news['topic_title'],
                'CREATED' => neFormatTimestamp($news['created'],'date'),     
				'AUTHOR' => $news['author'],
				'EDIT_LINK' => 'admin.php?mod=news&amp;op=edit&amp;id='.$news['article_id'],
                'EDIT' => $news['edit'],
                'EDIT_LINKS' => $news['edit_links'],
                'EDIT_IMAGES' => $news['edit_images'],
                'DELETE' => $news['delete'],
            ));
	        $tpl->parse('waitingnewsitem');
        }
    } else {
        $tpl->setVariable(array(
	    'LABEL_WAITING_NEWS' => neTranslate('news_waiting'),
	    'TEXT_NEWS_WAITING' => neTranslate('text-news_waiting'),
	    'TEXT_NO_NEWS_WAITING' => neTranslate('text-no_news_waiting')
	));
    }
    $newsWaiting->free();

    /* Build the database Query for the last News*/
    $strQuery  = 'SELECT news.article_id,topics.topic_id,topics.topic_name,';
    $strQuery .= 'topics.topic_title,news.author, news.created, news.title,';
    $strQuery .= 'news.abstract,news.text ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_news news, ';
    $strQuery .= $neConfig['db']['prefix']."_topics topics ";
    $strQuery .= 'WHERE topics.topic_id = news.topic ';
    $strQuery .= 'AND news.waiting = \'0\' ';
    $strQuery .='ORDER BY news.created DESC LIMIT 10';

    /* Fetch the last news */
    $newsWaiting = $neDb->query($strQuery);
    neGetDbError($newsWaiting,__LINE__,__FILE__,$strQuery);
    $tpl->setCurrentBlock('lastnews');
    $tpl->setVariable(array(
        'LABEL_LAST_NEWS' => neTranslate('last_news'),
        'TEXT_LAST_NEWS' => neTranslate('text-last_news'),
        'LABEL_TITLE' => neTranslate('title'),
        'LABEL_TOPIC' => neTranslate('topic'),
        'LABEL_CREATED' => neTranslate('created'),
        'LABEL_AUTHOR' => neTranslate('author'),
        'LABEL_FUNCTIONS' => neTranslate('functions'),
        'LABEL_NEW_ARTICLE' => neTranslate('new_article'),
        'LINK_NEW_ARTICLE' => 'admin.php?mod=news&amp;op=new'
    ));
    $tpl->setCurrentBlock('lastnewsitem');
    while ($newsWaiting->fetchInto($news,DB_FETCHMODE_ASSOC) ) {
        $news['author'] = $neTheme->getUserInfo($news['author']);
        $news['edit']  = '<a href="admin.php?mod=news&amp;op=edit&amp;';
		$news['edit'] .= 'id='.$news['article_id'].'">';
        $news['edit'] .= $neTheme->getImage('edit',neTranslate('edit'));
        $news['edit'] .= '</a>';
        $news['edit_links']  = '<a href="admin.php?mod=news&amp;op=edit_links&amp;';
		$news['edit_links'] .= 'id='.$news['article_id'].'">';
        $news['edit_links'] .= $neTheme->getImage('link',neTranslate('edit'));
        $news['edit_links'] .= '</a>';
        $news['delete']  = '<a href="admin.php?mod=news&amp;op=delete&amp;';
		$news['delete'] .= 'id='.$news['article_id'].'" ';
        $news['delete'] .= $neTheme->getImage('delete',neTranslate('delete'));
        $news['delete'] .= '</a>';
        $news['title_link'] = '<a href="index.php?mod=news&amp;op=show_article';
		$news['title_link'] .= '&amp;id='.$news['article_id'].'">';
		$news['title_link'] .= $news['title'].'</a>';
		$tpl->setVariable(array(
	        'TITLE' => $news['title_link'],
        	'TOPIC_TITLE' => $news['topic_title'],
        	'AUTHOR' => $news['author'],
	    	'CREATED' => neFormatTimestamp($news['created'],'date'),
        	'EDIT' => $news['edit'],
        	'EDIT_LINKS' => $news['edit_links'],
			'DELETE' => $news['delete']
	    ));
        $tpl->parse('lastnewsitem');
    }
    $tpl->touchBlock('lastnews');
    $newsWaiting->free();
    $tpl->show();
    $neTheme->drawSite(neTranslate('admin news',1));
}

function editArticle($intId){
    global $neConfig,$neDb, $neTheme;
    $strQuery  = 'SELECT ';
    $strQuery .= 'article_id,';
    $strQuery .= 'author,';
    $strQuery .= 'topic,';   
    $strQuery .= 'created,';
    $strQuery .= 'title,';
    $strQuery .= 'abstract,';
    $strQuery .= 'text ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_news news, ';
    $strQuery .= $neConfig['db']['prefix']."_topics topics, ";
    $strQuery .= $neConfig['db']['userprefix'].'_users users ';
    $strQuery .= 'WHERE article_id = '.$intId.' ';
    $strQuery .= 'AND topics.topic_id = news.topic ';
    $arrFormdata = $neDb->getRow($strQuery,DB_FETCHMODE_ASSOC);
    neGetDbError($arrFormdata,__LINE__,__FILE__,$strQuery);
    drawPreview($arrFormdata);
    drawEditForm($arrFormdata,'edit');
    $neTheme->drawSite( neTranslate('edit_article') );
}

?>
