<?php
/*==NukeEvent Portal System=====================================================
Copyright 2002 by Christian Berg

Code based on PHP-NUKE Web Portal System Copyright (c) 2002 by
Francisco Burzi (fbc@mandrakesoft.com) http://phpnuke.org

This program is free software. You can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 or any higher Version
of the License.
==============================================================================*/
/**
* This is the News Module for Nuke-Event.
* This File Displays an overview of the Articles
* @package news
* @author $Author: x-eniac $
* @version $Revision: 1.1 $
*/
neGetlang($neModuleName);
/**
* load the configuration for the News Module.
*/

require_once ('modules/news/config.php');
/**
* load the common Functions for the News Module.
*/
require_once ('modules/news/news_functions.php');
//==Main Routine================================================================
if (isset($_POST['article_id'])) {
    $intId= (int) $_POST['article_id'];
} elseif (isset($_GET['id'])) {
    $intId= (int) $_GET['id'];
}
if (isset($_GET['topic'])) {
    $intTopic= $_GET['topic'];
} else {
    $intTopic = null;
}
if ($neModuleLoader == 'admin.php' and empty($neOp)) {
    $neOp= 'admin_news';
}
//administrative operations
if ($neSession -> isAdmin($neModuleName)) {
    switch ($neOp) {
        case 'activate' :
            include_once ('modules/'.$neModuleName.'/admin_functions.php');
            submitEditArticle($_POST);
            activateArticle($intId);
            neRedirect("admin.php?mod=news&op=admin_news");
            break;
        case 'deactivate' :
            include_once ('modules/news/admin_functions.php');
            submitEditArticle($_POST);
            deactivateArticle($intId);
            neRedirect("admin.php?mod=news&op=admin_news");
            die();
            break;
        case 'delete' :
            include_once ('modules/news/admin_functions.php');
            showDeleteQuestion($intId);
            die();
            break;
        case 'delete_article' :
            include_once ('modules/news/admin_functions.php');
            deleteArticle($intId);
            neRedirect('admin.php?mod=news&op=admin_news');
            break;
        case 'submit_edit' :
            include_once ('modules/news/admin_functions.php');
            submitEditArticle($_POST);
            neRedirect("admin.php?mod=news&op=admin_news");
            break;
        case 'edit' :
            include_once ('modules/news/admin_functions.php');
            editArticle($intId);
            die();
            break;
        case 'admin_news' :
            include_once ('modules/news/admin_functions.php');
            adminNews();
            break;

//Functions for article related hyperlinks
        case 'add_link' :
            include_once ('modules/news/link_functions.php');
            addLink($intId, $_POST['link_name'], $_POST['link_url']);
            die();
            break;
        case 'delete_link' :
            include_once ('modules/news/link_functions.php');
            deleteLink($intId, $_GET['article']);
            break;
        case 'edit_links' :
            include_once ('modules/news/link_functions.php');
            editLinks($intId);
            break;
        
//Functions for article related images
        case 'upload_images' :
            include_once ('modules/news/image_functions.php');
            addLink($intId, $_POST['link_name'], $_POST['link_url']);
            die();
            break;
        case 'delete_image' :
            include_once ('modules/news/image_functions.php');
            deleteLink($intId, $_GET['article']);
            break;
        case 'edit_images' :
            include_once ('modules/news/image_functions.php');
            editLinks($intId);
            break;
    }
}
//operations to write new articles
if (($neConfig['news']['allow_user_post'] and $neSession -> isLoggedIn()) OR ($neSession -> isAdmin($neModuleName))) {
    switch ($neOp) {
        case 'preview' :
            include_once('modules/news/article_functions.php');
            previewArticle($_POST);
            die();
            break;
        case 'new' :
            include_once('modules/news/article_functions.php');
            newArticle($_POST);
            die();
            break;
        case 'submit_add' :
            include_once('modules/news/article_functions.php');
            submitNewArticle($_POST);
            die();
            break;
    }
}
//operations to generate RSS Feeds
if ($neConfig['news']['rssfeeds']) {
    switch ($neOp) {
        case 'show_rss' :
            include_once ('modules/news/news_rssfeed.php');
            showRss($intTopic);
            die();
            break;
    }
}
//standard operations (always accessable)
switch ($neOp) {
    case 'show_article' :
        include_once ('modules/news/article_functions.php');
        showArticle($intId);
        break;
    default :
        include ('modules/'.$neModuleName.'/news_index.php');
        displayIndex($intTopic);
        break;
}
?>
