<?php
/**
* draws the optionfields for the block permissions.
* Possible options are all users,registed users and only admins.
* @param integer default the permission that sould be the default value.
*/
function drawBlockpermissionOptions($default){
    ($default == BLOCK_ONLYADMIN) ? ($selected = 'selected="selected"') : 
    ($selected = '');
    echo '<option value="'.BLOCK_ONLYADMIN.'" '.$selected.'>';
    echo _('only admins');
    echo '</option>';

    ($default == BLOCK_ONLYREGISTED) ? ($selected = 'selected="selected"') : 
    ($selected = '');
    echo '<option value="'.BLOCK_ONLYREGITED.'" '.$selected.'>';
    echo _('only registed users');
    echo '</option>';

    ($default == BLOCK_ALLUSERS) ? ($selected = 'selected="selected"') : 
    $selected = '';
    echo '<option value="'.BLOCK_ALLUSERS.'" '.$selected.'>';
    echo _('all users');
    echo '</option>';
    return true;
}

/**
* draws the optionfields for the block position.
* Possible options are all left,right and center.
* @param integer default the permission that sould be the default value.
*/
function drawBlockpositionOptions($default){
    $default == BLOCK_LEFT ? $selected = 'selected="selected"' : 
    $selected = '';
    echo '<option value="'.BLOCK_LEFT.'" '.$selected.'>';
    echo _('left side');
    echo '</option>';

    $default == BLOCK_CENTER ? $selected = 'selected="selected"' : 
    $selected = '';
    echo '<option value="'.BLOCK_CENTER.'" '.$selected.'>';
    echo _('center');
    echo '</option>';

    $default == BLOCK_RIGHT ? $selected = 'selected="selected"' : 
    $selected = '';
    echo '<option value="'.BLOCK_RIGHT.'" '.$selected.'>';
    echo _('right side');
    echo '</option>';
}

/**
 * writes the changes to the database.
 * @param array an array with all tablefields that sould be changed.
 * @param integer the block_id of the block that should be changed.
 * @param boolean set tue true if you want to create a new block
 */
function submitChanges($arrBlock,$bolMode=0,$intBlockId=NUL)
{
    global $neConfig, $neDb, $neTheme;
    echo '<pre>';
    var_dump($arrBlock);
    echo '</pre>';
    $strQuery  = 'UPDATE '.$neConfig['db']['prefix'].'_blocks ';
    $strQuery .= "SET ";
    $strQuery .= "title='$arrBlock[title]',";
    $strQuery .= "block_type='$arrBlock[block_type]',";
    $strQuery .= "position='$arrBlock[position]',";
    $strQuery .= "visible='$arrBlock[visible]',";
    $strQuery .= "url='$arrBlock[url]',";
    $strQuery .= "content='$arrBlock[content]' ";
    $strQuery .= "WHERE block_id='$intBlockId' ";

    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
    $neTheme->drawSite();
}
/**
* Adds a Block to the Blockstable
*/
function submitAdd(){
    global $neConfig,$neDb, $neTheme;
    /* Get the next block ID */
    $strQuery   = 'SELECT block_id ';
    $strQuery  .= 'FROM '.$neConfig['db']['prefix'].'_blocks ';
    $strQuery  .= 'ORDER BY block_id DESC LIMIT 1';
    $intBlockId = $neDb->getOne($strQuery)+1;
    neGetDbError($intBlockId,__LINE__,__FILE__);

    /* Add Row into Database */
    $strQuery  = 'INSERT INTO '.$neConfig['db']['prefix'].'_blocks (block_id,title) ';
    $strQuery .= "VALUES($intBlockId,'new_block')";
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__);
    neRedirect('admin.php?mod='.MODULE_NAME.'&op=edit_block&id='.$intBlockId);
}

/**
 * Sets a Block to active.
 * @param integer Module ID.
 */
function activateBlock($intId)
{
    global $neConfig, $neDb, $neTheme;
    $strQuery  = 'UPDATE '.$neConfig['db']['prefix'].'_blocks '; 
    $strQuery .= "SET active='1' ";
    $strQuery .= "WHERE block_id='$intId'";
    $result = $neDb->query($strQuery);
    if (DB::isError($result)) {
        $neTheme->drawErrorpage(
            $result->getMessage(),
            $result->getMessage()
        );
    } else {
        neRedirect('admin.php?mod=blocks');
    }
}


/**
 * Sets a Module to inactive.
 * @param integer Module ID.
 */
function deactivateBlock($intId)
{
    global $neConfig, $neDb, $neTheme;
    $strQuery  = 'UPDATE '.$neConfig['db']['prefix'].'_blocks '; 
    $strQuery .= "SET active='0' ";
    $strQuery .= "WHERE block_id='$intId'";
    $result = $neDb->query($strQuery);
    if (DB::isError($result)) {
        $neTheme->drawErrorpage(
            $result->getMessage(),
            $result->getMessage()
        );
    } else {
        neRedirect('admin.php?mod=blocks');
    }
}
/**
 * decrement position for a block
 */
function decrementBlockPosition($intBlockId)
{
    $decrementBlockId = $intBlockId;
    $decrementBlockWeight = $neDb->getOne(
        'SELECT weight FROM '.$neConfig['db']['prefix'].'_blocks'
    );
    $incrementBlockWeight = $neDb->getOne(
        'SELECT weight FROM '.$neConfig['db']['prefix'].'_blocks 
        WHERE weight<'.$intBlockId
    );
}

/**
 * increment position for a block
 */
function incrementBlockPosition($intBlockId)
{

}

/**
 * Changes the Access Permissions from the Modules
 */
function changeBlocksSettings($arrPermissions,$arrWeight)
{
    global $neConfig, $neDb, $neTheme;
    $strModulesTable = $neConfig['db']['prefix'].'_modules';
    foreach($arrPermissions as $intId => $intView) {
        $strQuery = "UPDATE $strModulesTable SET view='$intView' ";
        $strQuery.= "WHERE module_id='$intId'";
        $result = $neDb->query($strQuery);
        if (DB::isError($result)) {
            themeErrorpage(
                $result->getMessage(),
                _($result->getMessage())
            );
        }
    }
    header("Location: ".$neConfig['site']['url']."/admin.php?mod=module-admin&amp;op=admin_modules");
}


/**
 * A function to edit some Parameter of a Module
 */
function addBlock()
{
    global $neConfig, $neTheme;   
    $arrBlock = array(
        'title'=> 'type the title here',
		'block_type'=>'1',
		'content' => '',
		        
    );
    $neTheme->drawTitle(_('add a new block'));
    drawBlockForm($arrBlock,'submit_add',null);
    $neTheme->drawSite();
}

/**
 * A function to edit some Parameter of a Module
 */
function editBlock($intBlockId)
{
    global $neConfig, $neDb, $neTheme;   
    $bolMode = 0;
    $strQuery  = 'SELECT * ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_blocks ';
    $strQuery .= "WHERE block_id = '$intBlockId'";
    $block = $neDb->getRow($strQuery, DB_FETCHMODE_ASSOC);
    neGetDbError($block,__LINE__,__FILE__,$strQuery);
    $intBlockId = (int) $block['block_id'];
    $neTheme->drawTitle(_($block['title']));
    drawBlockForm($block,'submit_edit',$intBlockId);
    $neTheme->drawSite();
}


function drawBlockForm($block,$strOp,$intBlockId)
{    
   ?>
  <form method="post">
  <input type="hidden" name="mod" value="<?=MODULE_NAME?>" />
  <input type="hidden" name="op" value="<?=$strOp?>" />
  <input type="hidden" name="id" value="<?=$intBlockId?>" />
  <input type="hidden" name="mode" value="<?=$bolMode?>" />

  <table class="formtable" cellpadding="0" cellspacing="0">
   <tr><td class="formheader" colspan="2"><?= _('edit Block');?></td></tr>
   <tr class="formtable">
    <td class="formdescr"><?= _('Blocktitle')?></td>
    <td class="formelement">
     <input type="text" class="text" name="block[title]" value="<?=$block['title']?>" size="60"/>
    </td>
   </tr>
   <tr class="formtable">
   <td class="formdescr"><?= _('Block position');?></td>
    <td class="formelement">
     <select name="block[position]" class="select">
     <?=drawBlockpositionOptions($block['position']);?>
    </select></td>
   </tr>

   <tr class="formtable">
    <td class="formdescr"><?= _('Visible for');?></td>
    <td class="formelement">
     <select name="block[visible]">
     <?=drawBlockpermissionOptions($block['visible']);?>
     </select>
     </td>
   </tr>

   <tr class="formtable">
   <td class="formheader" colspan="2"><?= _('Block type')?></td>
   </tr>
   <tr class="formtable">
    <td class="formdescr">
     <input type="radio" class="radio" name="block[block_type]" value="0"
     <?php if ($block['block_type'] == 0) echo 'checked="checked"';?> />
     <?= _('Block Module');?></td>
    <td class="formelement">
    <select class="select" name="block[file]">
     <?=drawBlockmouduleOptions;?>
    </select>
    </td>
   </tr>
   <tr class="formtable">
    <td class="formdescr">
    <input type="radio" class="radio" name="block[block_type]" value="2"
    <?php if ($block['block_type'] == 2) echo 'checked="checked';?> />
    <?= _('RSS Newsfeed')?>
    </td>
    <td class="formelement">
     <input type="text" name="block[url]" value="<?=$block['url']?>" class="text" size="60" />
    </td>
   </tr>
   <tr class="formtable">
    <td class="formdescr">
    <input type="radio" class="radio" name="block[block_type]" value="1"
    <?php if ($block['block_type'] == 1) echo 'checked="checked" ';?> />
    <?= _('HTML Block')?>
    </td>
    <td class="formelement"><textarea cols="60" rows="10" name="block[content]" class="textarea"><?= $block['content'];?></textarea></td>
   </tr>
   <tr class="formtable">
    <td class="formbuttons" colspan="2">
     <input type="reset">
     <input type="submit">
    </td>
   </tr>
  </table>
</form>
    <?php
}

/**
 * Shows a Table with the all Blocks. to sort them.
 */
function adminBlocks()
{
    global $neConfig, $neDb, $neTheme;
    $neTheme->drawTitle(_('Blocks adminstration'));
    echo '<h3>'._('Left Blocks').'</h3>';
    drawBlocksTable(BLOCK_LEFT);
    echo '<h3>'._('Center Blocks').'</h3>';
    drawBlocksTable(BLOCK_CENTER);
    echo '<h3>'._('Right Blocks').'</h3>';
    drawBlocksTable(BLOCK_RIGHT);
    $neTheme->DrawSite();
}

function drawBlocksTable($position){
    global $neConfig, $neDb,$neTheme;
    $strModulesTable = $neConfig['db']['prefix'].'_blocks';
    $strQuery  = 'SELECT block_id, title, weight, language, visible, active, position, module ';
    $strQuery .= 'FROM '.$strModulesTable.' ';
    $strQuery .= 'WHERE position=\''.$position.'\' ';
    $strQuery .= 'ORDER BY weight';
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__);
    ?>
    <form action="admin.php" method="post">
    <input type="hidden" name="mod" value="<?php echo MODULE_NAME;?>" />
    <input type="hidden" name="op" value="change_modules_permissions" />
    <table class="tableview" width="100%">
     <tr class="tableview">
      <th class="tableview"><?php echo _('sequence');?></th>
      <th class="tableview"><?php echo _('title');?></th>
      <th class="tableview"><?php echo _('show_in');?></th>
      <th class="tableview"><?php echo _('active');?></th>
      <th class="tableview"><?php echo _('visible_for');?></th>
      <th class="tableview"><?php echo _('functions');?></th>
     </tr>
    <?php
    $class = '';
    while ($block = $result->fetchRow(DB_FETCHMODE_ASSOC) ){
    if ($class == 'tableview'){
        $class = 'tableview2';
    } else {
        $class = 'tableview';
    }
    ?>
     <tr class="<?=$class?>">
      <td class="tableview">
       <a href="admin.php?mod=blocks&amp;move_up&amp;id=<?=$block['block_id']?>"><?php echo $neTheme->drawImage('up','up');?></a>
       <a href="admin.php?mod=blocks&amp;move_down&amp;id=<?=$block['block_id']?>"><?php echo $neTheme->drawImage('down','down');?></a>
      </td>
      <td class="<?=$class?>">
       <?php echo $block['title'];?>
      </td>
      <td class="<?=$class?>">
       <?php echo $block['module'];?>
      </td>
      <td align="center" class="<?=$class?>"><?php
      if ($block['active'] == 1 ) {
          echo '<a href="admin.php?mod=blocks&amp;op=deactivate&amp;id='.$block['block_id'].'">';
          $neTheme->drawImage('ledgreen',_('active'));
          echo '</a>';
      } else {
          echo '<a href="admin.php?mod=blocks&amp;op=activate&amp;id='.$block['block_id'].'">';
          $neTheme->drawImage('ledred',_('inactive'));
          echo '</a>';
      }
      ?>
      </td>
      <td class="<?=$class?>">
       <?php
        echo '<select name="view['.$block['block_id'].']">';

        echo '</select>';
       ?>
      </td>
      <td class="<?=$class?>" align="right">
       <a href="admin.php?mod=blocks&amp;op=edit_block&amp;id=<?php echo $block['block_id'];?>">
        <?php echo $neTheme->drawImage('edit',_('edit'));?>
       </a>
       <a href="admin.php?mod=blocks&amp;op=delete_block&amp;id=<?php echo $block['block_id'];?>">
        <?php echo $neTheme->drawImage('delete',_('delete'));?>
       </a>
      </td>
     </tr>
     <?php
    }
     ?>
     <tr>
      <td colspan="8" class="formbuttons">
       <input type="submit" value="<?php echo _('change_settings')?>">
      </td>
     </tr>
    </table>
   </form>
   <?php
}
?>
