<?php

/**
* include the functions needed for comments Module
*/
include_once('modules/comments/comments_functions.php');

/**
* load the Config File for the comments Module
*/
include_once('modules/comments/config.inc.php');

/* Load the Language File for the Comments Module */
neGetLang('comments');

/**
*/
function showReplys($commentId,$tableName,$tpl)
{
	global $neDb;
    $strQuery  = 'SELECT * ';
    $strQuery .= 'FROM '.$tableName.' ';
    $strQuery .= 'WHERE reply_to='.$neDb->quote($commentId);
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
    if ($result->numRows() > 0) {
        while($result->fetchInto($comment,DB_FETCHMODE_ASSOC)) {
            $tpl->setVariable( array(
            'REPLY_TITLE'  => $comment['comment_title'],
            'REPLY_AUTHOR' => $comment['comment_author'],
            'REPLY_DATE' => neFormatTimestamp($comment['comment_date'],'date'),
            'REPLY_TEXT' => $comment['comment_text']
            ));
        }
        //showReplys($comment['comment_id'],$tableName,$tpl);
    }            
}        

/**
*/
function showComments($tableName,$threadId,$redirectUrl)
{
    global $neModuleName, $neTheme ,$neConfig, $neDb, $neSession;
    $tpl = $neTheme->getTemplate('comments','comments.tpl');
    $strQuery  = 'SELECT * ';
    $strQuery .= 'FROM '.$tableName.' ';
    $strQuery .= 'WHERE  thread_id='.$neDb->quote($threadId).' ';
    $strQuery .= 'AND reply_to=0';
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
    if ($result->numRows() > 0) {   
        while($result->fetchInto($comment,DB_FETCHMODE_ASSOC)) {
            $tpl->setCurrentBlock('comment');
            $date = neFormatTimestamp(intval($comment['comment_date']),'date');
            $tpl->setVariable( array(
            'COMMENT_ID'  => $comment['comment_id'],
            'COMMENT_TITLE'  => $comment['comment_title'],
            'COMMENT_AUTHOR' => $neTheme->getUserinfo($comment['comment_author']),
            'COMMENT_DATE' => $date,
            'COMMENT_TEXT' => neEncodeUbb($comment['comment_text'])
            ));
            //showReplys($comment['comment_id'],$tableName,$tpl);
            $tpl->parse('comment');
        }
    }
    if ($neConfig['comments']['quickcomment']) {
    	echo 'quickcomment';
        $tpl->setCurrentBlock('write_comment');
        $tpl->setVariable( array(
            'REDIRECT_URL'  => $redirectUrl,
            'THREAD_ID'  => $threadId,
            'TABLE_NAME'  => $tableName,
            'AUTHOR' => $neSession->getId(),
            'COMMENT_TEXTBOX' => $neTheme->getUbbBox('comment[text]','',3,50),
            'LABEL_TITLE' => neTranslate('title'),
            'LABEL_WRITE_COMMENT' => neTranslate('write_comment'),
            'LABEL_TEXT' => neTranslate('comment')
        ));
        $tpl->touchBlock('write_comment');
    }
            
    return $tpl->get();
}

function submitComment($arrFormdata,$strRedirectUrl){
	global $neDb;
	echo '<pre>';
	var_dump($arrFormdata);
	var_dump($strRedirectUrl);
	
	$commentId = $neDb->quote(time());
	$threadId  = $neDb->quote(intval($arrFormdata['thread_id']));
	$author    = $neDb->quote(intval($arrFormdata['author']));
	$date = $neDb->quote(time());
	$title = $neDb->quote(neChecktext($arrFormdata['title'],'plain'));
	$text = $neDb->quote(neChecktext($arrFormdata['text'],'ubb'));
	$reply  = $neDb->quote(intval($arrFormdata['reply']));

	$strQuery  = 'INSERT INTO  `'.$arrFormdata['table_name'].'`';
	$strQuery .= '(comment_id,thread_id,comment_author,comment_date,';
	$strQuery .= 'comment_title,comment_text,reply_to) ';
	$strQuery .= "VALUES ($commentId,$threadId,$author,$date,$title,$text,";
	$strQuery .= "$reply)";
	$result = $neDb->query($strQuery);
	negetDbError($result,__LINE__,__FILE__,$strQuery);
}
?>