<?php
/**
* Draw the Main Indexsite with all Toplevel Categories.
*
* The Main Indexsite shows all toplevel categories.
* @global string $neModuleName
* @global array  $neConfig
* @global handle $neDb
*/
function drawCategory($intCatId)
{
    global $neModuleName, $neConfig, $neDb, $neTheme, $neSession;

    /*Load the Template*/
    $tpl = $neTheme->getTemplate('webdir','category.tpl');

    /*Get the Category Name*/
    $strQuery = 'SELECT cat_name ';
    $strQuery.= 'FROM '.$neConfig['db']['prefix'].'_webdir_categories ';
    $strQuery.= 'WHERE cat_id = '.$intCatId;
    $strCatName = $neDb->getOne($strQuery);

    /* Common Content for the Template */
    $tpl->setVariable(array(
        'CATEGORY_NAME' => $strCatName,
        'TRAIL' => getBreadcrumbs($intCatId),
        'SUGGEST_LINK' => '<a href="index.php?mod='.$neModuleName
                         .'&amp;op=suggest&amp;cat='.$intCatId.'">'.neTranslate('suggest_link').'</a>'
    ));

    /* Show the Subcategories of this Category*/
    $strQuery = 'SELECT cat_id, cat_name ';
    $strQuery.= 'FROM '.$neConfig['db']['prefix'].'_webdir_categories ';
    $strQuery.= 'WHERE parent = '.$intCatId.' ';
    $strQuery.= 'ORDER BY cat_name ASC';
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__);

    $tpl->setCurrentBlock('subcategories');
    while ( $subCat = $result->fetchRow(DB_FETCHMODE_ASSOC) ) {
        $tpl->setVariable(array(
            'SUBCAT_NAME' => $subCat['cat_name'],
            'SUBCAT_LINK' => 'index.php?mod='.$neModuleName.'&amp;cat='.$subCat['cat_id'],
            'SUBCAT_DESCRIPTION' => $subCat['cat_description']
        ));
        $tpl->parse('subcat');
    }
    $result->free();


    /* Show the Links in this Category*/
    $strQuery = 'SELECT url, link_name, description ';
    $strQuery.= 'FROM '.$neConfig['db']['prefix'].'_webdir_links ';
    $strQuery.= 'WHERE cat_iD = '.$intCatId.' AND approved=\'1\' ';
    $strQuery.= 'ORDER BY link_name ASC';
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__);

    $tpl->setCurrentBlock('links');
    while(list($strLinkUrl,$strLinkName, $strLinkDesc) = $result->fetchRow()){
        $tpl->setVariable(array(
            'LINK_URL' => $strLinkUrl,
            'LINK_NAME' => $strLinkName,
            'LINK_DESCRIPTION' => $strLinkDesc
        ));
        $tpl->parse('link');
    }
    $result->free();
   
    if ( $neSession->isAdmin($neModuleName) ) {
        $tpl->setCurrentBlock('admin');
        $tpl->setVariable(array(
            'LABEL_NEW_LINKS' => neTranslate('new_links'),            
            'ADD_CAT_LINK' => '<a href="index.php?mod='.$neModuleName.
                              '&amp;op=add_cat&amp;cat='.$intCatId
                              .'">'.neTranslate('add_category').'</a>'
        ));
	}
    $tpl->show();
    $neTheme->drawSite();
}
?>
