<?php

/**
 * Display the Article Text
 */
function drawArticle($arrData){
    global $neModuleName, $neTheme ,$neConfig, $neDb, $neSession;
    $tpl = $neTheme->getTemplate($neModuleName,'news_article.tpl');

    $strQuery  = 'SELECT topic_id,topic_name,topic_title ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_topics ';
    $strQuery .= 'WHERE  topic_id='.$arrData['topic'];
    $arrTopic = $neDb->getRow($strQuery,DB_FETCHMODE_ASSOC);
    neGetDbError($arrTopic,__LINE__,__FILE__,$strQuery);
    /* set the article data */
    $tpl->setVariable( array(
    'ARTICLE_ID'  => (int) $arrData['article_id'],
    'AUTHOR'      => neGetUserName($arrData['author']),
    'CREATED'     => neFormatTimestamp($arrData['created'],'date'),
    'TITLE'       => neCheckText($arrData['title'],'plaintext'),
    'ABSTRACT'    => neCheckText($arrData['abstract'],'plain'),
    'TEXT'        => neEncodeUbb(neCheckText($arrData['text'],'ubb')),
    'COUNTER'     => strlen($arrData['abstract']) + strlen($arrData['text']),
    'TOPIC_ID'  => (int) $arrTopic['topic_id'],
    'TOPIC_NAME'  => neCheckText($arrTopic['topic_name'],'plain'),
    'TOPIC_TITLE' => neCheckText($arrTopic['topic_title'],'plain')
    ));
    include_once('modules/comments/comments_functions.php');
    $tpl->setVariable('COMMENTS',showComments(
        $neConfig['db']['prefix'].'_news_comments',
        $arrData['article_id'],
        'index.php?mod=news&op=show_article&id='.$arrData['article_id']
     ));
     
    /* Show the Admin Functions. */ 
    if ( $neSession->isAdmin('news') ) {
        $tpl->setVariable(array(
 		'NEW_LINK' => '<a href="admin.php?mod=news&amp;op=new">'.$neTheme->getImage('new', neTranslate('new_article')).'</a>',
		'DELETE_LINK' => '<a href="admin.php?mod=news&amp;op=delete_article&amp;id='.$arrData['article_id'].'">'.$neTheme->getImage('delete',neTranslate('delete')).'</a>',
		'EDIT_LINK' => '<a href="admin.php?mod=news&amp;op=edit&amp;id='.$arrData['article_id'].'">'.
                      $neTheme->getImage('edit',neTranslate('edit')).'</a> ',
		'EDIT_LINKS_LINK' => '<a href="admin.php?mod=news&amp;op=edit_links&amp;id='.$arrData['article_id'].'">'.$neTheme->getImage('link',neTranslate('edit_links')).'</a> '
        ));
    }
    //Set the Images
    if ( $neTheme->getImageSrc('news/'.$arrData['article_id'].'_small')) { 
        $tpl->setVariable('IMAGE',$neTheme->getImageSrc('news/'.$arrData['article_id'].'_small'));
	} else {
	    $tpl->setVariable('IMAGE', $neTheme->getImageSrc('topics/'.$arrTopic['topic_name']));
    }
	if ( $neTheme->getImageSrc('news/'.$arrData['article_id'].'_big')) { 
        $tpl->setVariable('BIG_IMAGE',$neTheme->getImageSrc('news/'.$arrData['article_id'].'_big'));
	}
    /* Parse Topiclinks */	
    $strQuery  = 'SELECT link_title, link_url ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_news_links ';
    $strQuery .= 'WHERE article_id = '.$arrData['article_id'];
    $newslinks = $neDb->query($strQuery);
    negetDbError($newslinks,__LINE__,__FILE__,$strQuery);
    if ( $newslinks->numRows() > 0) {    
        $tpl->setVariable( 'LABEL_RELATED_LINKS',neTranslate('related_links'));
        $tpl->setCurrentBlock('news_link');
        while ($newslinks->fetchInto($link,DB_FETCHMODE_ASSOC) ){
            $tpl->setVariable('LINK_URL',$link['link_url']);
            $tpl->setVariable('LINK_NAME',$link['link_title']);
            $tpl->parse('news_link');
        }
    }

    /* Parse Topiclinks */	
    $strQuery  = 'SELECT link_title, link_url ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_topics_links ';
    $strQuery .= 'WHERE topic_id = '.$arrTopic['topic_id'];
    $topiclinks = $neDb->query($strQuery);
    negetDbError($topiclinks,__LINE__,__FILE__,$strQuery);
    if ( $topiclinks->numRows() > 0) {    
        $tpl->setVariable( 'LABEL_RELATED_LINKS',neTranslate('related_links'));
        $tpl->setCurrentBlock('topic_link');
        while ($topiclinks->fetchInto($link,DB_FETCHMODE_ASSOC) ){
            $tpl->setVariable('LINK_URL',$link['link_url']);
            $tpl->setVariable('LINK_NAME',$link['link_title']);
            $tpl->parse('topic_link');
        }
    }
    unset($article,$arrData);
    $tpl->show();
    return true;
}

function showArticle($intStoryId){
    global $neDb, $neConfig, $neTheme, $neModuleName, $neSession;
    $strQuery  = 'SELECT  *';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_news news ';
    $strQuery .= 'WHERE article_id = '.$intStoryId.' ';
    $arrData = $neDb->getRow($strQuery,DB_FETCHMODE_ASSOC);
    neGetDbError($arrData,__LINE__,__FILE__,$strQuery);
    if (is_array($arrData) ) {
        drawArticle($arrData);
    } else {
        $neTheme->drawErrorpage('','');
    }        
    $neTheme->drawSite();
}

function submitNewArticle($arrFormdata) {
    global $neDb,$neConfig,$neTheme,$neSession;
    if (empty($arrFormdata['article_id'])) {
        $arrFormdata['article_id'] = time();
    }
    $arrSubmitdata['article_id'] = (int) $arrFormdata['article_id'];
    $arrSubmitdata['topic'] = (int) $arrFormdata['topic'];
    $arrSubmitdata['title'] = $neDb->quote(neCheckText($arrFormdata['title']));
    $arrSubmitdata['author'] = $neDb->quote(
	    neCheckText($arrFormdata['author'],'plain')
	);
    $arrSubmitdata['abstract'] = $neDb->quote(neChecktext($arrFormdata['abstract'],'plain'));
    $arrSubmitdata['text'] = $neDb->quote(
        neChecktext($arrFormdata['text'],'ubb')
    );
    $strQuery  = 'INSERT INTO '.$neConfig['db']['prefix'].'_news ';
    $strQuery .= '(article_id,title,author,topic,abstract,text,created) ';
    $strQuery .= 'VALUES(';
    $strQuery .= "$arrSubmitdata[article_id],";
    $strQuery .= "$arrSubmitdata[title],";
    $strQuery .= "$arrSubmitdata[author],";
    $strQuery .= "$arrSubmitdata[topic],";
    $strQuery .= "$arrSubmitdata[abstract],";
    $strQuery .= "$arrSubmitdata[text],";
    $strQuery .= 'NOW()';
    $strQuery .= ')';
    $result = $neDb->query($strQuery);
    neGetDbError($result,__LINE__,__FILE__,$strQuery);
   if ( $neSession->isAdmin('news') ) {
       require('admin_functions.php');
       activateArticle($arrSubmitdata['article_id']);
   }
	neRedirect('admin.php?mod=news&op=show_article&id='.$arrSubmitdata['article_id']);
}

function newArticle() {
    global $neSession,$neOp, $neTheme;
    $arrFormdata=array(
        'author' => $neSession->getId(),
        'op' => $neOp,
        'article_id' => time(),
        'title' => '',
        'title' => '',
        'abstract' => '',
        'text' => ''
    );
    $neTheme->drawTitle(neTranslate('new_article'));
    drawEditForm($arrFormdata);
    $neTheme->drawSite(neTranslate('new_article'));
}

function previewArticle($arrFormdata) {
    global $neSession,$neOp, $neTheme;
    $neTheme->drawTitle(neTranslate('preview'));
    drawPreview($arrFormdata);
    drawEditForm($arrFormdata,$arrFormdata['mode']);
    $neTheme->drawSite();
}
?>