<?php

function getOpSelect($strMode) {
    $strOp = '<option value="preview">'.neTranslate('preview').'</option>';
    if ($strMode == 'edit') {
       $strOp .= '<option value="submit_edit">'.neTranslate('edit').'</option>';
       $strOp .= '<option value="activate">'.neTranslate('activate').'</option>';
       $strOp .= '<option value="deactivate">'.neTranslate('deactivate').'</option>';
    } else {
        $strOp .= '<option value="submit_add">'.neTranslate('submit').'</option>';
    }
    return $strOp;
}

function getTopicSelect($intDefault) {
    global $neConfig,$neSession, $neDb;
    $strQuery  = 'SELECT topic_id, topic_title ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_topics ';
    $strQuery .= 'ORDER BY topic_title';
    $toplist = $neDb->query($strQuery);
    neGetDbError($toplist,__LINE__,__FILE__,$strQuery);
    $strReturn = '';
    while(list($intId, $strTitle) = $toplist->fetchRow() ) {
        if ( $intDefault == $intId ) {
            $strSelected = 'selected="selected"';
        } else {
            $strSelected = '';
        }
        $strReturn .= '<option value="'.$intId.'" '.$strSelected.'>';
        $strReturn .= $strTitle;
        $strReturn .= '</option>'."\n";
    }
    return $strReturn;
}

/**
* Draws the Form to edit oder add an Article
*/
function drawEditForm($arrFormdata,$strMode='add') 
{
    global $neModuleName, $neSession, $neTheme, $neOp;
    $tpl=$neTheme->getTemplate('news','edit_form.tpl');
    $tpl->setVariable(array(
    'LABEL_EDIT_ARTICLE' => neTranslate('edit_article'),
    'LABEL_TITLE' => $neTheme->getHelpLink(
                                   neTranslate('title'),
                   'news',
                   'news_submit',
                   'title'
                   ),
    'LABEL_AUTHOR' => $neTheme->getHelpLink(
                                   neTranslate('author'),
                   'news',
                   'news_submit',
                   'author'
                ),
    'LABEL_TOPIC' => $neTheme->getHelpLink(
                                   neTranslate('topic'),
                   'news',
                   'news_submit',
                   'topic'
                   ),
    'LABEL_ABSTRACT' => $neTheme->getHelpLink(
                                      neTranslate('abstract'),
                      $neModuleName,
                      'news_submit',
                      'abstract'
                  ),
    'LABEL_TEXT' => $neTheme->getHelpLink(
                                  neTranslate('text'),
                  $neModuleName,
                  'news_submit',
                  'text'
                              ),
    'MODULE' => neCheckText($neModuleName,'plain'),
    'MODE' => $strMode,
    'OP'   => getOpSelect($strMode),
    'ARTICLE_ID' => $arrFormdata['article_id'],
    'TITLE' => $arrFormdata['title'],
    'AUTHOR'=> $arrFormdata['author'],
    'AUTHOR_NAME' => $neTheme->getUserInfo($arrFormdata['author']),
    'TOPIC' => getTopicSelect($arrFormdata['topic']),
    'EDIT_TOPICS_LINK' => '<a href="admin.php?mod=topics">'
                          .$neTheme->getImage('edit',neTranslate('edit')).'</a>',
    'ABSTRACT' => stripcslashes($arrFormdata['abstract']),
    'TEXT' => $neTheme->getUbbBox('text',stripslashes($arrFormdata['text']))    
    ));
    $tpl->setVariable('SMALL_IMAGE',$neTheme->getImage('news/'.$arrFormdata['article_id'].'_small',$arrFormdata['title']));
    $tpl->setVariable('BIG_IMAGE',$neTheme->getImage('news/'.$arrFormdata['article_id'].'_big',$arrFormdata['title']));
    $tpl->touchBlock('form');
    $tpl->show();
}

/**
 * Display the Article Text
 */
function drawPreview($arrData){
    global $neModuleName, $neTheme ,$neConfig, $neDb, $neSession;
    $tpl = $neTheme->getTemplate($neModuleName,'news_article.tpl');
    if ( empty($arrData['topic_id'])) {
        $strQuery  = 'SELECT topic_id,topic_name,topic_title ';
        $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_topics ';
        $strQuery .= 'WHERE  topic_id='.$arrData['topic'];
        $arrTopic = $neDb->getRow($strQuery,DB_FETCHMODE_ASSOC);
        neGetDbError($arrTopic,__LINE__,__FILE__,$strQuery);
    } 
    /* set the article data */
    $tpl->setVariable( array(
    'ARTICLE_ID'  => (int) $arrData['article_id'],
    'AUTHOR'      => neGetUserName($arrData['author']),
    'CREATED'     => neFormatTimestamp(time()),
    'TITLE'       => neCheckText($arrData['title'],'plaintext'),
    'ABSTRACT'    => neCheckText($arrData['abstract'],'plain'),
    'TEXT'        => neEncodeUbb(neCheckText($arrData['text'],'ubb')),
    'COUNTER'     => strlen($arrData['abstract']) + strlen($arrData['text']),
    'TOPIC_ID'  => (int) $arrTopic['topic_id'],
    'TOPIC_NAME'  => neCheckText($arrTopic['topic_name'],'plain'),
    'TOPIC_TITLE' => neCheckText($arrTopic['topic_title'],'plain')
    ));
     
    //Set the Images
    if ( $neTheme->getImageSrc('news/'.$arrData['article_id'].'_small')) { 
        $tpl->setVariable('IMAGE',$neTheme->getImageSrc('news/'.$arrData['article_id'].'_small'));
    } else {
        $tpl->setVariable('IMAGE', $neTheme->getImageSrc('topics/'.$arrTopic['topic_name']));
    }
    if ( $neTheme->getImageSrc('news/'.$arrData['article_id'].'_big')) { 
        $tpl->setVariable('BIG_IMAGE',$neTheme->getImageSrc('news/'.$arrData['article_id'].'_big'));
    }
    /* Parse Topiclinks */  
    $strQuery  = 'SELECT link_title, link_url ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_news_links ';
    $strQuery .= 'WHERE article_id = '.$arrData['article_id'];
    $newslinks = $neDb->query($strQuery);
    negetDbError($newslinks,__LINE__,__FILE__,$strQuery);
    if ( $newslinks->numRows() > 0) {    
        $tpl->setVariable( 'LABEL_RELATED_LINKS',neTranslate('related_links'));
        $tpl->setCurrentBlock('news_link');
        while ($newslinks->fetchInto($link,DB_FETCHMODE_ASSOC) ){
            $tpl->setVariable('LINK_URL',$link['link_url']);
            $tpl->setVariable('LINK_NAME',$link['link_title']);
            $tpl->parse('news_link');
        }
    }

    /* Parse Topiclinks */  
    $strQuery  = 'SELECT link_title, link_url ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_topics_links ';
    $strQuery .= 'WHERE topic_id = '.$arrTopic['topic_id'];
    $topiclinks = $neDb->query($strQuery);
    negetDbError($topiclinks,__LINE__,__FILE__,$strQuery);
    if ( $topiclinks->numRows() > 0) {    
        $tpl->setVariable( 'LABEL_RELATED_LINKS',neTranslate('related_links'));
        $tpl->setCurrentBlock('topic_link');
        while ($topiclinks->fetchInto($link,DB_FETCHMODE_ASSOC) ){
            $tpl->setVariable('LINK_URL',$link['link_url']);
            $tpl->setVariable('LINK_NAME',$link['link_title']);
            $tpl->parse('topic_link');
        }
    }
    unset($article,$arrData);
    $tpl->show();
    return true;
}
?>
