<?php

/**
 * Displays the latest News.
 */
function displayIndex($intTopic= NULL) {
    global $neConfig, $neDb, $neTheme, $neSession;
    /*Load the Template File*/
    $tpl = $neTheme->getTemplate('news','news_index.tpl') or die('x_X');
    $tpl->printWarning = true;

    /*Build the SQL Query */
    $strQuery  = 'SELECT news.article_id, topics.topic_id, topics.topic_name,topics.topic_title, ';
    $strQuery .= 'users.username, news.created, news.title, news.abstract, news.text ';
    $strQuery .= 'FROM '.$neConfig['db']['prefix'].'_news news, ';
    $strQuery .= $neConfig['db']['prefix']."_topics topics, ";
    $strQuery .= $neConfig['db']['userprefix'].'_users users ';
    $strQuery .= 'WHERE users.uid = news.author ';
    $strQuery .= 'AND topics.topic_id = news.topic ';
    $strQuery .= 'AND news.waiting = \'0\' ';
   
    /* if a Topic Id is given, show only news from this topic */
    if ($intTopic > 0 ) {
        $strQuery .= "AND news.topic = '$intTopic' ";
    }
    $strQuery .='ORDER BY news.created DESC ';

    /* Fetch the Topnews */
    $strQueryTop = $strQuery . 'LIMIT '.$neConfig['news']['top'];
    $newsTop = $neDb->query($strQueryTop);
    neGetDbError($newsTop,__LINE__,__FILE__,$strQueryTop);
    $tpl->setCurrentBlock('topnewsitem');
    while ($news = $newsTop->fetchRow(DB_FETCHMODE_ASSOC)) {
        $strMorelink = "index.php?mod=news&amp;op=show_article&amp;id=".$news['article_id'];  
        $tpl->setVariable(array(
		'TOP_TITLE' => $news['title'],
        'TOP_AUTHOR' => $news['username'],
        'TOP_CREATED' => neFormatTimestamp($news['created'],'date'),
        'TOP_TOPIC_TITLE' => $news['topic_title'],
        'TOP_TOPIC_ID' => $news['topic_id'],
        'TOP_ABSTRACT' => $news['abstract'],
        'TOP_MORE_LINK' => $strMorelink,
		));
    if ( $neTheme->getImageSrc('news/'.$news['article_id'].'_small')) { 
        $tpl->setVariable('TOP_IMAGE',$neTheme->getImageSrc('news/'.$news['article_id'].'_small'));
	} else {
	    $tpl->setVariable('TOP_IMAGE', $neTheme->getImageSrc('topics/'.$news['topic_name']));
    }
        $tpl->parse('topnewsitem');
	}	
    $newsTop->free();
 
    /* Fetch the older news */
    $strQueryOld = $strQuery . 'LIMIT '.$neConfig['news']['top'].','.$neConfig['news']['old'];
    $newsOld = $neDb->query($strQueryOld);
    neGetDbError($newsOld,__LINE__,__FILE__,$strQueryOld);
    $tpl->setCurrentBlock('oldnewsitem');
    while ($news = $newsOld->fetchRow(DB_FETCHMODE_ASSOC)) {
        $strMorelink = "index.php?mod=news&amp;op=show_article&amp;id=".$news['article_id'];
        $strTopicImage= 'topics/'.$news['topic_name'];
        $tpl->setVariable(array(
		    'OLD_TITLE' => $news['title'],
            'OLD_AUTHOR' => $news['username'],
            'OLD_CREATED' => $news['created'],
            'OLD_TOPIC_TITLE' => $news['topic_title'],
            'OLD_ABSTRACT' => $news['abstract'],
            'OLD_TOPIC_IMAGE' => $strTopicImage,
            'OLD_MORE_LINK' => $strMorelink
		));
        $tpl->parse('oldnewsitem');
    }
    $newsOld->free();
    if ($neSession->isAdmin('news') ) {
	    $strQuery  = 'SELECT article_id ';
		$strQuery .= 'FROM '.$neConfig['db']['prefix'].'_news ';
		$strQuery .= 'WHERE waiting=1';
		$result = $neDb->query($strQuery);
		neGetDbError($result,__LINE__,__FILE__,$strQuery);
		$numWaiting = $result->numRows();
        $tpl->setCurrentBlock('admin');
        $tpl->setVariable(array(
		    'LABEL_ARTICLES_WAITING' => neTranslate('articles_waiting'),
			'ARTICLES_WAITING' => '<a href="admin.php?mod=news">'
                                  .$numWaiting.'</a>',
			'NEW_ARTICLE' => '<a href="admin.php?mod=news&amp;op=new">'
			                 .neTranslate('new_article').'</a>'
		));
	}
    $tpl->show();
    $neTheme->drawSite();
}
?>
