<?php

/**
* The Setuproutine for the Topics Module:
*
* @package nukeevent.modules.topics
* @author $Author: cberg $
* @version $Revision: 1.2 $
*/

function install()
{
    global $neDb, $neConfig;
    addModule('webdir','Web Directory');
	addAdminmenu('webdir','admin_webdir','Admin Directory');
	addAdminmenu('webdir','add_Link','Add a Link');
	addAdminmenu('webdir','add_category','Add Category');

    $strQuery  = 'CREATE TABLE IF NOT EXISTS '.$neConfig['db']['prefix'].'_webdir_categories (';
    $strQuery .= 'cat_id   int(10)      NOT NULL,';
    $strQuery .= 'cat_name varchar(32)  NOT NULL,';
    $strQuery .= 'parent   int(10)      NOT NULL default \'0\',';
    $strQuery .= 'cat_desc varchar(255) default NULL,';
    $strQuery .= 'symbolic int(1)       NOT NULL default \'0\',';
    $strQuery .= 'target   int(10)      default NULL,';
    $strQuery .= 'PRIMARY KEY (cat_id))';
    $result = $neDb->query($strQuery);
    negetDbError($result,__LINE__,__FILE__,$strQuery);

    $strQuery  = 'CREATE TABLE IF NOT EXISTS '.$neConfig['db']['prefix'].'_webdir_links (';
    $strQuery .= 'link_id     int(32)      NOT NULL, ';
    $strQuery .= 'cat_id      int(10)      NOT NULL, ';
    $strQuery .= 'url         varchar(255) NOT NULL, ';
    $strQuery .= 'link_name   varchar(64)  NOT NULL, ';
    $strQuery .= 'description varchar(255) NOT NULL, ';
    $strQuery .= 'approved    int(1)       NOT NULL default \'0\', ';
    $strQuery .= 'submitter   int(10) 	   NOT NULL, ';
    $strQuery .= 'submit_date datetime 	   NOT NULL, ';
    $strQuery .= 'PRIMARY KEY (link_id), ';
    $strQuery .= 'UNIQUE KEY  link_name (link_name,cat_id), ';
    $strQuery .= 'UNIQUE KEY  Url (url,cat_id))';
    $result = $neDb->query($strQuery);
    negetDbError($result,__LINE__,__FILE__,$strQuery);

}

function uninstall() {
    global $neDb, $neConfig;
    removeModule('webdir','Web Directory');
    removeAdminmenu('webdir');
    $strQuery  = 'DROP TABLE '.$neConfig['db']['prefix'].'_webdir_links';
    $result = $neDb->query($strQuery);
    negetDbError($result,__LINE__,__FILE__,$strQuery); 
    $strQuery  = 'DROP TABLE  '.$neConfig['db']['prefix'].'_webdir_categories';
    $result = $neDb->query($strQuery);
    negetDbError($result,__LINE__,__FILE__,$strQuery); 
}

switch ($neOp){
    case 'install_module':
        install();
        $neTheme->drawSite();
        break;
	case 'uninstall_module':
	    uninstall();
		neRedirect('admin.php?mod=modules');
}
?>
